if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface Index_Params {
    pathStack?: NavPathStack;
    qqOpenApi?: IQQOpenApi;
}
import hilog from "@ohos:hilog";
import { Constants } from "@normalized:N&&&@tencent/qq-open-sdk/Index&1.0.3";
import type { IQQOpenApi } from "@normalized:N&&&@tencent/qq-open-sdk/Index&1.0.3";
import { QQOpenApiHolder } from "@normalized:N&&&entry/src/main/ets/util/QQOpenApiHolder&";
import { showDialog } from "@normalized:N&&&entry/src/main/ets/util/AlertUtils&";
import { LoginTestComponent } from "@normalized:N&&&entry/src/main/ets/pages/LoginTestComponent&";
import { SharePage } from "@normalized:N&&&entry/src/main/ets/pages/SharePage&";
const TAG = "Demo.IndexPage";
class Index extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.pathStack = new NavPathStack();
        this.qqOpenApi = QQOpenApiHolder.getInstance();
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: Index_Params) {
        if (params.pathStack !== undefined) {
            this.pathStack = params.pathStack;
        }
        if (params.qqOpenApi !== undefined) {
            this.qqOpenApi = params.qqOpenApi;
        }
    }
    updateStateVars(params: Index_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private pathStack: NavPathStack;
    private qqOpenApi: IQQOpenApi;
    onPageShow(): void {
        // this.qqOpenApi.handleAuthResult(router.getParams())
        hilog.debug(0x0000, TAG, "isQQInstalled: " + this.qqOpenApi.isQQInstalled());
    }
    PagesMap(name: string, parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            If.create();
            if (name == 'pages/SharePage') {
                this.ifElseBranchUpdateFunction(0, () => {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        __Common__.create();
                        __Common__.width('100%');
                        __Common__.height('100%');
                    }, __Common__);
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let componentCall = new SharePage(this, {}, undefined, elmtId, () => { }, { page: "entry/src/main/ets/pages/Index.ets", line: 26, col: 7 });
                                ViewPU.create(componentCall);
                                let paramsLambda = () => {
                                    return {};
                                };
                                componentCall.paramsGenerator_ = paramsLambda;
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {});
                            }
                        }, { name: "SharePage" });
                    }
                    __Common__.pop();
                });
            }
            else {
                this.ifElseBranchUpdateFunction(1, () => {
                });
            }
        }, If);
        If.pop();
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Navigation.create(this.pathStack, { moduleName: "entry", pagePath: "entry/src/main/ets/pages/Index", isUserCreateStack: true });
            Navigation.navDestination({ builder: this.PagesMap.bind(this) });
            Navigation.title("互联SDK演示 v" + Constants.SDK_VER);
            Navigation.mode(NavigationMode.Auto);
        }, Navigation);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 10 });
            Column.width('100%');
            Column.height('100%');
            Column.justifyContent(FlexAlign.Center);
        }, Column);
        this.buildLoginPart.bind(this)();
        this.buildBottomPart.bind(this)();
        Column.pop();
        Navigation.pop();
    }
    buildLoginPart(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('100%');
            __Common__.height('60%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let componentCall = new LoginTestComponent(this, {}, undefined, elmtId, () => { }, { page: "entry/src/main/ets/pages/Index.ets", line: 44, col: 5 });
                    ViewPU.create(componentCall);
                    let paramsLambda = () => {
                        return {};
                    };
                    componentCall.paramsGenerator_ = paramsLambda;
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "LoginTestComponent" });
        }
        __Common__.pop();
    }
    buildBottomPart(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 10 });
            Column.justifyContent(FlexAlign.Center);
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('检查是否安装QQ');
            Button.width('40%');
            Button.onClick((event) => {
                showDialog(this.qqOpenApi.isQQInstalled() ? "已安装" : "未安装");
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('分享');
            Button.width('40%');
            Button.onClick((event) => {
                // router.pushUrl({ url: 'pages/SharePage' })
                this.pathStack.pushPath({ name: 'pages/SharePage' });
            });
        }, Button);
        Button.pop();
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "Index";
    }
}
registerNamedRoute(() => new Index(undefined, {}), "", { bundleName: "com.tencent.qqopensdkdemo.db", moduleName: "entry", pagePath: "pages/Index", pageFullPath: "entry/src/main/ets/pages/Index", integratedHsp: "false", moduleType: "followWithHap" });
