if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface SharePage_Params {
    qqOpenApi?: IQQOpenApi;
    shareDataController?: TextAreaController;
    shareDataSignController?: TextAreaController;
    timeStamp?: number;
    nonce?: number;
    shareData?: string;
    shareDataSign?: string;
}
import hilog from "@ohos:hilog";
import { ShareData, ShareResultType } from "@normalized:N&&&@tencent/qq-open-sdk/Index&1.0.3";
import type { IQQOpenApi, ShareResult } from "@normalized:N&&&@tencent/qq-open-sdk/Index&1.0.3";
import { showDialog, toast } from "@normalized:N&&&entry/src/main/ets/util/AlertUtils&";
import { PreferenceUtils } from "@normalized:N&&&entry/src/main/ets/util/PreferenceUtils&";
import { demoGenSign } from "@normalized:N&&&entry/src/main/ets/util/ShareDataUtils&";
import { QQOpenApiHolder } from "@normalized:N&&&entry/src/main/ets/util/QQOpenApiHolder&";
const TAG = "Demo.SharePage";
export class SharePage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.qqOpenApi = QQOpenApiHolder.getInstance();
        this.shareDataController = new TextAreaController();
        this.shareDataSignController = new TextAreaController();
        this.__timeStamp = new ObservedPropertySimplePU(0, this, "timeStamp");
        this.__nonce = new ObservedPropertySimplePU(0, this, "nonce");
        this.__shareData = new ObservedPropertySimplePU('{"msg_style": 0, "title":"鸿蒙ARK图文", "summary":"ARK分享的内容", "brief":"互联分享", "url":"https://www.qq.com", "picture_url":"https://tangram-1251316161.file.myqcloud.com/files/20200722/796170665c821b9a1982918094aa6ba7.png"}', this, "shareData");
        this.__shareDataSign = new ObservedPropertySimplePU('', this, "shareDataSign");
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: SharePage_Params) {
        if (params.qqOpenApi !== undefined) {
            this.qqOpenApi = params.qqOpenApi;
        }
        if (params.shareDataController !== undefined) {
            this.shareDataController = params.shareDataController;
        }
        if (params.shareDataSignController !== undefined) {
            this.shareDataSignController = params.shareDataSignController;
        }
        if (params.timeStamp !== undefined) {
            this.timeStamp = params.timeStamp;
        }
        if (params.nonce !== undefined) {
            this.nonce = params.nonce;
        }
        if (params.shareData !== undefined) {
            this.shareData = params.shareData;
        }
        if (params.shareDataSign !== undefined) {
            this.shareDataSign = params.shareDataSign;
        }
    }
    updateStateVars(params: SharePage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__timeStamp.purgeDependencyOnElmtId(rmElmtId);
        this.__nonce.purgeDependencyOnElmtId(rmElmtId);
        this.__shareData.purgeDependencyOnElmtId(rmElmtId);
        this.__shareDataSign.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__timeStamp.aboutToBeDeleted();
        this.__nonce.aboutToBeDeleted();
        this.__shareData.aboutToBeDeleted();
        this.__shareDataSign.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private qqOpenApi: IQQOpenApi;
    private shareDataController: TextAreaController;
    private shareDataSignController: TextAreaController;
    private __timeStamp: ObservedPropertySimplePU<number>;
    get timeStamp() {
        return this.__timeStamp.get();
    }
    set timeStamp(newValue: number) {
        this.__timeStamp.set(newValue);
    }
    private __nonce: ObservedPropertySimplePU<number>;
    get nonce() {
        return this.__nonce.get();
    }
    set nonce(newValue: number) {
        this.__nonce.set(newValue);
    }
    private __shareData: ObservedPropertySimplePU<string>;
    get shareData() {
        return this.__shareData.get();
    }
    set shareData(newValue: string) {
        this.__shareData.set(newValue);
    }
    private __shareDataSign: ObservedPropertySimplePU<string>;
    get shareDataSign() {
        return this.__shareDataSign.get();
    }
    set shareDataSign(newValue: string) {
        this.__shareDataSign.set(newValue);
    }
    onPageShow(): void {
        // this.qqOpenApi.handleAuthResult(router.getParams())
        hilog.debug(0x0000, TAG, "isQQInstalled: " + this.qqOpenApi.isQQInstalled());
        this.timeStamp = PreferenceUtils.load('share_timestamp', 0) as number;
        this.nonce = PreferenceUtils.load('share_nonce', 0) as number;
        this.shareData = PreferenceUtils.load('share_content', '') as string;
        this.shareDataSign = PreferenceUtils.load('share_sign', '') as string;
    }
    alert(message: string) {
        AlertDialog.show({
            message: message,
            backgroundColor: { "id": 125829507, "type": 10001, params: [], "bundleName": "com.tencent.qqopensdkdemo.db", "moduleName": "entry" },
            backgroundBlurStyle: BlurStyle.NONE
        });
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            NavDestination.create(() => {
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Column.create({ space: 10 });
                    Column.width('100%');
                    Column.height('100%');
                    Column.justifyContent(FlexAlign.Start);
                    Column.alignItems(HorizontalAlign.Start);
                    Column.margin({ top: 50 });
                    Column.padding(10);
                }, Column);
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Text.create('分享内容：');
                }, Text);
                Text.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    TextArea.create({
                        placeholder: '分享内容',
                        text: `${this.shareData}`,
                        controller: this.shareDataController
                    });
                    TextArea.onChange((value: string) => {
                        this.shareData = value;
                        PreferenceUtils.save('share_content', value);
                    });
                    TextArea.maxLines(13);
                }, TextArea);
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Row.create();
                }, Row);
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Text.create('时间戳: ');
                    Text.width(80);
                }, Text);
                Text.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    TextInput.create({ placeholder: '时间戳', text: String(this.timeStamp) });
                    TextInput.onChange((value: string) => {
                        try {
                            let number = Number(value);
                            this.timeStamp = number;
                        }
                        catch (e) {
                            this.timeStamp = 0;
                        }
                        PreferenceUtils.save('share_timestamp', this.timeStamp);
                    });
                    TextInput.type(InputType.Number);
                    TextInput.copyOption(CopyOptions.InApp);
                    TextInput.width('80%');
                }, TextInput);
                Row.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Row.create();
                }, Row);
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Text.create('随机整数: ');
                    Text.width(80);
                }, Text);
                Text.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    TextInput.create({ placeholder: '随机整数', text: String(this.nonce) });
                    TextInput.copyOption(CopyOptions.InApp);
                    TextInput.type(InputType.Number);
                    TextInput.onChange((value: string) => {
                        try {
                            let number = Number(value);
                            this.nonce = number;
                        }
                        catch (e) {
                            this.nonce = 0;
                        }
                        PreferenceUtils.save('share_nonce', this.nonce);
                    });
                    TextInput.width('80%');
                }, TextInput);
                Row.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Text.create('签名');
                }, Text);
                Text.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    TextArea.create({
                        placeholder: this.shareDataSign,
                        text: `${this.shareDataSign}`,
                        controller: this.shareDataSignController
                    });
                    TextArea.onChange((value: string) => {
                        PreferenceUtils.save('share_sign', value);
                    });
                }, TextArea);
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Button.createWithLabel('生成时间戳并计算签名');
                    Button.width('60%');
                    Button.onClick(async (event) => {
                        // 生成时间戳
                        this.timeStamp = Date.parse(new Date().toString()) / 1000;
                        // 生成随机整数
                        this.nonce = Math.floor(Math.random() * 100000000 + 100);
                        // 生成签名
                        this.shareDataSign =
                            await demoGenSign(QQOpenApiHolder.getInstance().appId, this.shareData, this.timeStamp, this.nonce);
                    });
                }, Button);
                Button.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Button.createWithLabel('计算签名');
                    Button.width('60%');
                    Button.onClick(async (event) => {
                        // 生成签名
                        this.shareDataSign =
                            await demoGenSign(QQOpenApiHolder.getInstance().appId, this.shareData, this.timeStamp, this.nonce);
                    });
                }, Button);
                Button.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Button.createWithLabel('点击分享');
                    Button.width('60%');
                    Button.onClick((event) => {
                        this.testShare();
                    });
                }, Button);
                Button.pop();
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    Button.createWithLabel('加好友');
                    Button.width('60%');
                    Button.onClick((event) => {
                        this.testAddFriend();
                    });
                    Button.visibility(Visibility.Hidden);
                }, Button);
                Button.pop();
                Column.pop();
            }, { moduleName: "entry", pagePath: "entry/src/main/ets/pages/SharePage" });
            NavDestination.mode(NavDestinationMode.STANDARD);
        }, NavDestination);
        NavDestination.pop();
    }
    async testAddFriend() {
        let shareData: ShareData = new ShareData();
        shareData.timestamp = this.timeStamp;
        shareData.nonce = this.nonce;
        shareData.shareJson = this.shareData;
        shareData.shareJsonSign = this.shareDataSign;
        hilog.debug(0x0000, 'SharePage', `shareJson: ${this.shareData}, ${this.shareData.length}`);
        let result: ShareResult = await this.qqOpenApi.share(3006, shareData);
        switch (result.resultType) {
            case ShareResultType.Success:
                {
                    toast("分享成功");
                }
                break;
            case ShareResultType.Cancel:
                {
                    let msg: string = result.message ?? "用户取消分享";
                    toast(msg);
                }
                break;
            case ShareResultType.Error:
                {
                    let msg: string = result.message ?? "分享失败";
                    showDialog(msg);
                }
                break;
        }
    }
    testShare() {
        let shareData: ShareData = new ShareData();
        shareData.timestamp = this.timeStamp;
        shareData.nonce = this.nonce;
        shareData.shareJson = this.shareData;
        shareData.shareJsonSign = this.shareDataSign;
        showDialog(JSON.stringify(shareData, null, 4), () => {
            this.qqOpenApi.share(2, shareData).then((result: ShareResult) => {
                switch (result.resultType) {
                    case ShareResultType.Success:
                        {
                            toast("分享成功");
                        }
                        break;
                    case ShareResultType.Cancel:
                        {
                            let msg: string = result.message ?? "用户取消分享";
                            toast(msg);
                        }
                        break;
                    case ShareResultType.Error:
                        {
                            let msg: string = result.message ?? "分享失败";
                            showDialog(msg);
                        }
                        break;
                }
            });
        });
    }
    rerender() {
        this.updateDirtyElements();
    }
}
