import hilog from "@ohos:hilog";
import JSON from "@ohos:util.json";
import { PreferenceUtils } from "@normalized:N&&&entry/src/main/ets/util/PreferenceUtils&";
const TAG = "HttpUtils";
export class HttpUtils {
    private constructor() {
    }
    static autoLogin(appId: string): Promise<AccessTokenJson> {
        return new Promise<AccessTokenJson>((resolve, reject) => {
            let newLocal: AccessTokenJson | null = PreferenceUtils.loadTicket(appId);
            hilog.debug(0x0000, TAG, 'loadLocal: ' + JSON.stringify(newLocal));
            if (newLocal && !!newLocal.access_token) {
                resolve(newLocal);
                return;
            }
            reject("no local data");
        });
    }
    static getAccessToken(appId: string, authCode: string): Promise<AccessTokenJson> {
        let promise = new Promise<AccessTokenJson>((resolve, reject) => {
            // TODO 从业务后台获取token
        });
        return promise;
    }
    private static log(msg: string) {
        hilog.debug(0x0000, TAG, msg);
    }
}
export interface AccessTokenJson {
    access_token: string;
    expires_in: number;
    openid: string;
    refresh_token: string;
}
